SystemOrganization addCategory: #'Roassal2-Plugins-CProjectVisualizer'!
SystemOrganization addCategory: 'Roassal2-Plugins-CProjectVisualizer-Core'!
SystemOrganization addCategory: 'Roassal2-Plugins-CProjectVisualizer-Scripts'!
SystemOrganization addCategory: 'Roassal2-Plugins-CProjectVisualizer-Tests'!

RTTest subclass: #CPPFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Tests'!

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:39'!
testFileReference

	self assert: CPPFile new fileReference notNil! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 13:39'!
testFileReference02
	| f1 f2 |
	f1 := CPPFile new.
	f1 filename: '/tmp/foo.c'.
	self assert: f1 fileReference notNil.
	
	f2 := CPPFile new.
	f2 filename: '/tmp/foo.c'.
	self assert: f2 fileReference notNil.
	self assert: f2 fileReference ~~ f1 fileReference.! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:38'!
testFilename
	self assert: CPPFile new filename equals: 'UNAMED'.
	self assert: (CPPFile new filename: 'foo.h'; filename) equals: 'foo.h'.! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:36'!
testLOC

	self assert: CPPFile new loc equals: -1.
	self assert: (CPPFile new loc: 10; loc) equals: 10! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:33'!
testPrintOn

	self assert: CPPFile new printString equals: 'a CPPFile<UNAMED>'! !

RTTest subclass: #CPPFolderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Tests'!

!CPPFolderTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:48'!
testBasic
	self assert: CPPFolder new numberOfFiles equals: 0! !

RTTest subclass: #CPPProcessor2Test
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Tests'!

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 12:23'!
file01
	^ 
'
#include "util/foo.h"

void main() { 
}
'! !

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 13:34'!
file02
	^ 
'
// Foo.hpp
'! !

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 12:23'!
file03
	^ 
'
#include <foo.h>
#include <foo2.h>
#include <bar.h>

void zork() { 
}
'! !

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 12:23'!
file04
	^ 
'
// bar.h
#include <foo.h>
#include <foo2.h>

void zork();
'! !

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 12:23'!
file05
	^ 
'
#include "foo.h"

'! !

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 14:09'!
file06NodDotC
	^ 
'
#include "Nod.h"
#include <nuclear>

#include "message/input/ServoID.h"
#include "message/motion/Script.h"
#include "message/behaviour/Action.h"
#include "message/support/Configuration.h"
#include "message/behaviour/Nod.h"

'! !

!CPPProcessor2Test methodsFor: 'code example' stamp: 'AlexandreBergel 11/30/2016 14:09'!
file07NodDotH
	^ 
'
#ifndef MESSAGE_BEHAVIOUR_NOD_H
#define MESSAGE_BEHAVIOUR_NOD_H

#include <armadillo>

namespace message {
namespace behaviour {
    struct Nod {
    	Nod(bool value) : value(value) {
    	}
    	
    	bool value;
    };

}
}

#endif


'! !

!CPPProcessor2Test methodsFor: 'running' stamp: 'AlexandreBergel 11/30/2016 12:23'!
setUp
	super setUp.
	p := CPPProcessor new! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:24'!
testBasic
	| m h |
	p processFileAsString: self file01 named: 'util/foo.c'.
	p processFileAsString: self file02 named: 'util/foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:25'!
testBasic01
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'util/foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:28'!
testBasic01bis
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 13:34'!
testBasic01bisbis
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.hpp'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 13:42'!
testBasic01bisbisbis
	| m h |
	p processFileAsString: self file01 named: 'foo.cpp'.
	p processFileAsString: self file02 named: 'foo.hpp'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:23'!
testBasic02
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.

	self assert: (p moduleNamed: 'foo.c') equals: p modules anyOne.
	self assert: (p headerNamed: 'foo.h') equals: p headers anyOne.
	self assert: (p moduleNamed: 'foo.h') isNil.
	self assert: (p headerNamed: 'foo.c') isNil.! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:23'!
testBasic03
	| h1 h2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 2.
	self assert: p numberOfModules equals: 2.
	
	h1 := p headerNamed: 'bar.h'.
	h2 := p headerNamed: 'foo.h'.
	self assert: h1 incomingHeaders isEmpty.
	self assert: h1 outgoingHeaders size equals: 1.
	
	self assert: h2 incomingHeaders size equals: 1.
	self assert: h2 incomingHeaders anyOne equals: h1.! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:23'!
testBasic04
	| m1  m2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:23'!
testBasic05
	| m |
	p processFileAsString: self file05 named: 'foo.c'.
	p resolveDependencies.
	m := p moduleNamed: 'foo.c'.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'foo.h'! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:23'!
testBasic06
	| m1  m2 |
	p processFileAsString: self file01 named: '/abc/def/foo.c'.
	p processFileAsString: self file02 named: '/abc/def/foo.h'.
	p processFileAsString: self file03 named: '/abc/def/bar.c'.
	p processFileAsString: self file04 named: '/abc/def/bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 notNil.
	self assert: m2 notNil.
	
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessor2Test methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 12:23'!
testDefault

	self assert: p numberOfHeaders equals: 0.
	self assert: p numberOfModules equals: 0.! !

RTTest subclass: #CPPProcessor3Test
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Tests'!

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file01
	^ 
'
#include "util/foo.h"

void main() { 
}
'! !

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file02
	^ 
'
// Foo.hpp
'! !

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file03
	^ 
'
#include <foo.h>
#include <foo2.h>
#include <bar.h>

void zork() { 
}
'! !

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file04
	^ 
'
// bar.h
#include <foo.h>
#include <foo2.h>

void zork();
'! !

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file05
	^ 
'
#include "foo.h"

'! !

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file06NodDotC
	^ 
'
#include "Nod.h"
#include <nuclear>

#include "message/input/ServoID.h"
#include "message/motion/Script.h"
#include "message/behaviour/Action.h"
#include "message/support/Configuration.h"
#include "message/behaviour/Nod.h"

'! !

!CPPProcessor3Test methodsFor: 'code example' stamp: 'AlexandreBergel 3/8/2017 21:08'!
file07NodDotH
	^ 
'
#ifndef MESSAGE_BEHAVIOUR_NOD_H
#define MESSAGE_BEHAVIOUR_NOD_H

#include <armadillo>

namespace message {
namespace behaviour {
    struct Nod {
    	Nod(bool value) : value(value) {
    	}
    	
    	bool value;
    };

}
}

#endif


'! !

!CPPProcessor3Test methodsFor: 'running' stamp: 'AlexandreBergel 3/8/2017 21:08'!
setUp
	super setUp.
	p := CPPProcessor new! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:15'!
testBasic
	| m h |
	p processFileAsString: self file01 named: 'util/foo.cc'.
	p processFileAsString: self file02 named: 'util/foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic01
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'util/foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic01bis
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic01bisbis
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.hpp'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic01bisbisbis
	| m h |
	p processFileAsString: self file01 named: 'foo.cpp'.
	p processFileAsString: self file02 named: 'foo.hpp'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'util/foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic02
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.

	self assert: (p moduleNamed: 'foo.c') equals: p modules anyOne.
	self assert: (p headerNamed: 'foo.h') equals: p headers anyOne.
	self assert: (p moduleNamed: 'foo.h') isNil.
	self assert: (p headerNamed: 'foo.c') isNil.! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:10'!
testBasic03
	| h1 h2 |
	p processFileAsString: self file01 named: 'util/foo.c'.
	p processFileAsString: self file02 named: 'util/foo.h'.
	p processFileAsString: self file03 named: '/foo/zork/bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 2.
	self assert: p numberOfModules equals: 2.
	
	h1 := p headerNamed: 'bar.h'.
	h2 := p headerNamed: 'foo.h'.
	self assert: h1 incomingHeaders isEmpty.
	self assert: h1 outgoingHeaders size equals: 1.
	
	self assert: h2 incomingHeaders size equals: 1.
	self assert: h2 incomingHeaders anyOne equals: h1.! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic04
	| m1  m2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic05
	| m |
	p processFileAsString: self file05 named: 'foo.c'.
	p resolveDependencies.
	m := p moduleNamed: 'foo.c'.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'foo.h'! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testBasic06
	| m1  m2 |
	p processFileAsString: self file01 named: '/abc/def/foo.c'.
	p processFileAsString: self file02 named: '/abc/def/foo.h'.
	p processFileAsString: self file03 named: '/abc/def/bar.c'.
	p processFileAsString: self file04 named: '/abc/def/bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 notNil.
	self assert: m2 notNil.
	
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessor3Test methodsFor: 'tests' stamp: 'AlexandreBergel 3/8/2017 21:08'!
testDefault

	self assert: p numberOfHeaders equals: 0.
	self assert: p numberOfModules equals: 0.! !

RTTest subclass: #CPPProcessorTest
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Tests'!

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:12'!
file01
	^ 
'
#include <foo.h>

void main() { 
}
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:12'!
file02
	^ 
'
// Foo.h
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:13'!
file03
	^ 
'
#include <foo.h>
#include <foo2.h>
#include <bar.h>

void zork() { 
}
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:47'!
file04
	^ 
'
// bar.h
#include <foo.h>
#include <foo2.h>

void zork();
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 20:02'!
file05
	^ 
'
#include "foo.h"

'! !

!CPPProcessorTest methodsFor: 'running' stamp: 'AlexandreBergel 11/3/2016 19:13'!
setUp
	super setUp.
	p := CPPProcessor new! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:49'!
testBasic
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:32'!
testBasic02
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.

	self assert: (p moduleNamed: 'foo.c') equals: p modules anyOne.
	self assert: (p headerNamed: 'foo.h') equals: p headers anyOne.
	self assert: (p moduleNamed: 'foo.h') isNil.
	self assert: (p headerNamed: 'foo.c') isNil.! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:48'!
testBasic03
	| h1 h2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 2.
	self assert: p numberOfModules equals: 2.
	
	h1 := p headerNamed: 'bar.h'.
	h2 := p headerNamed: 'foo.h'.
	self assert: h1 incomingHeaders isEmpty.
	self assert: h1 outgoingHeaders size equals: 1.
	
	self assert: h2 incomingHeaders size equals: 1.
	self assert: h2 incomingHeaders anyOne equals: h1.! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:52'!
testBasic04
	| m1  m2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 20:10'!
testBasic05
	| m |
	p processFileAsString: self file05 named: 'foo.c'.
	p resolveDependencies.
	m := p moduleNamed: 'foo.c'.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'foo.h'! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 20:12'!
testBasic06
	| m1  m2 |
	p processFileAsString: self file01 named: '/abc/def/foo.c'.
	p processFileAsString: self file02 named: '/abc/def/foo.h'.
	p processFileAsString: self file03 named: '/abc/def/bar.c'.
	p processFileAsString: self file04 named: '/abc/def/bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 notNil.
	self assert: m2 notNil.
	
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:14'!
testDefault

	self assert: p numberOfHeaders equals: 0.
	self assert: p numberOfModules equals: 0.! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 16:02'!
testDependencies

	| m1C |
	p processFileAsString: 
'#include "m1.h"
#include "m3.h"
' named: 'm1.c'.
	p processFileAsString: '#include "m2.h"' named: 'm1.h'.

	p processFileAsString: '// m2.h' 			  named: 'm2.h'.
	p processFileAsString: '#include "m2.h"' named: 'm2.c'.

	p processFileAsString: '// m3.h' 			  named: 'm3.h'.
	p processFileAsString: '#include "m3.h"' named: 'm3.c'.
	p resolveDependencies.
	
	self assert: p modules size equals: 3.

	self assert: (p modules allSatisfy: #hasHeader).
	
	self assert: ((p headerNamed: 'm1.h') outgoingHeaders includes: (p headerNamed: 'm2.h')).
	
	m1C := p moduleNamed: 'm1.c'.
	self assert: (m1C outgoingHeaders includes: (p headerNamed: 'm3.h')).
	self assert: m1C dependentModules size equals: 2.
	
	
! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/30/2016 16:08'!
testDependenciesAndCpp

	| m1C |
	p processFileAsString: 
'#include "m1.hpp"
#include "m3.hpp"
' named: 'm1.cpp'.
	p processFileAsString: '#include "m2.hpp"' named: 'm1.hpp'.

	p processFileAsString: '// m2.hpp' 			  named: 'm2.hpp'.
	p processFileAsString: '#include "m2.hpp"' named: 'm2.cpp'.

	p processFileAsString: '// m3.hpp' 			  named: 'm3.hpp'.
	p processFileAsString: '#include "m3.hpp"' named: 'm3.cpp'.
	p resolveDependencies.
	
	self assert: p modules size equals: 3.

	self assert: (p modules allSatisfy: #hasHeader).
	
	self assert: ((p headerNamed: 'm1.hpp') outgoingHeaders includes: (p headerNamed: 'm2.hpp')).
	
	m1C := p moduleNamed: 'm1.cpp'.
	self assert: (m1C outgoingHeaders includes: (p headerNamed: 'm3.hpp')).
	self assert: m1C dependentModules size equals: 2.
	
	
! !

RTUsefulScript subclass: #RTVisualizeCPPApplicationHeaderScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Scripts'!

!RTVisualizeCPPApplicationHeaderScript methodsFor: 'accessing' stamp: 'AlexandreBergel 11/30/2016 12:30'!
description
	^ 
'Let you select a directory containing a C or C++ application and visualize it.
'! !

!RTVisualizeCPPApplicationHeaderScript methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2016 12:30'!
execute
	| s source |
	s := (self class >> #sourceCodeScript) sourceCode.
	source := String cr join: s lines allButFirst.
	GTPlayground openContents: source! !

!RTVisualizeCPPApplicationHeaderScript methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2016 12:31'!
label
	^ 'Visualize C/C++ application [ headers ]'! !

!RTVisualizeCPPApplicationHeaderScript methodsFor: 'script' stamp: 'AlexandreBergel 11/30/2016 12:31'!
sourceCodeScript
	"The following code shows dependencies between "
	| root p b |
	root := '/Users/alexandrebergel/Desktop/SUCHAI'.
	"root := '/Users/alexandrebergel/Desktop/NUbots'."
	p := CPPProcessor new.
	p processRootFolder: root asFileReference.
	p resolveDependencies.
	
	b := RTMondrian new.
	b shape circle 
		color: Color gray;
		if: [ :f | '*RTOS*' match: f filename ] color: Color red.
	b interaction highlightNeighbour: #outgoingHeaders color: Color orange .
"	b shape box size: #loc."
	b nodes: p headers.
	
	b shape line 
		color: (Color blue alpha: 0.2);
		width: 2.
	b edges 
		moveBehind;
		connectToAll: #outgoingHeaders.
	b layout grid.
	
	b normalizer normalizeSize: #loc.
	b! !

RTUsefulScript subclass: #RTVisualizeCPPApplicationModuleAndHeaderScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Scripts'!

!RTVisualizeCPPApplicationModuleAndHeaderScript methodsFor: 'accessing' stamp: 'AlexandreBergel 12/2/2016 12:39'!
description
	^ 
'Let you select a directory containing a C or C++ application and visualize it.
'! !

!RTVisualizeCPPApplicationModuleAndHeaderScript methodsFor: 'hooks' stamp: 'AlexandreBergel 12/2/2016 12:39'!
execute
	| s source |
	s := (self class >> #sourceCodeScript) sourceCode.
	source := String cr join: s lines allButFirst.
	GTPlayground openContents: source! !

!RTVisualizeCPPApplicationModuleAndHeaderScript methodsFor: 'hooks' stamp: 'AlexandreBergel 12/2/2016 12:40'!
label
	^ 'Visualize C/C++ application [ modules & headers ]'! !

!RTVisualizeCPPApplicationModuleAndHeaderScript methodsFor: 'script' stamp: 'AlexandreBergel 12/2/2016 12:39'!
sourceCodeScript
	"The following code shows dependencies between "
	| root p b |
	root := '/Users/alexandrebergel/Desktop/SUCHAI'.
	"root := '/Users/alexandrebergel/Desktop/NUbots'."
	"root := '/Users/alexandrebergel/Desktop/SUCHAI-Flight-Software'."
	p := CPPProcessor new.
	p processRootFolder: root asFileReference.
	p resolveDependencies.
	
	b := RTMondrian new.
	b shape circle 
		color: Color gray;
		if: [ :f | f class == CPPHeader ] borderColor: Color red;
		if: [ :f | '*/repo*' match: f filename ] color: Color blue;
		if: [ :f | '*/cmd*' match: f filename ] color: Color yellow;
		if: [ :f | '*/task*' match: f filename ] color: Color orange.
	b interaction highlightNeighbour:  #outgoingHeaders color: Color orange .
"	b shape box size: #loc."
	b nodes: p modules, p headers.
	
	
	b shape arrowedLine
		headOffset: 0.3;
		withOffset; 
		color: (Color blue alpha: 0.2);
		width: 2.
	b edges 
		moveBehind;
		connectToAll: #outgoingHeaders.
	b layout grid.
	"b layout forceWithCharge: -300."
	
	b normalizer normalizeSize: #loc using: #sqrt.
	b! !

RTUsefulScript subclass: #RTVisualizeCPPApplicationScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Scripts'!

!RTVisualizeCPPApplicationScript methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:02'!
description
	^ 
'Let you select a directory containing a C or C++ application and visualize it.
'! !

!RTVisualizeCPPApplicationScript methodsFor: 'hooks' stamp: 'AutoDeprecationRefactoring 11/3/2016 20:30'!
execute
	| s source |
	s := (self class >> #sourceCodeScript) sourceCode.
	source := String cr join: s lines allButFirst.
	GTPlayground openContents: source! !

!RTVisualizeCPPApplicationScript methodsFor: 'hooks' stamp: 'AlexandreBergel 11/30/2016 12:29'!
label
	^ 'Visualize C/C++ application [ modules ]'! !

!RTVisualizeCPPApplicationScript methodsFor: 'script' stamp: 'AlexandreBergel 11/3/2016 20:43'!
sourceCodeScript
	"The following code shows dependencies between "
	| root p b |
	root := '/Users/alexandrebergel/Desktop/SUCHAI'.
	p := CPPProcessor new.
	p processRootFolder: root asFileReference.
	p resolveDependencies.
	
	b := RTMondrian new.
	b shape circle 
		color: Color gray;
		if: [ :f | '*RTOS*' match: f filename ] color: Color red.
	b interaction highlightNeighbour:  #dependentModules color: Color orange .
"	b shape box size: #loc."
	b nodes: p modules.
	
	
	b shape line 
		color: (Color blue alpha: 0.2);
		width: 2.
	b edges 
		moveBehind;
		connectToAll: #dependentModules.
	b layout grid.
	"b layout forceWithCharge: -300."
	
	b normalizer normalizeSize: #loc.
	b! !

RTObject subclass: #CPPAbstractFile
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Core'!

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/30/2016 13:40'!
fileReference
	"Return the file reference"
	^ self filename asFileReference! !

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:42'!
filename
	^ filename! !

!CPPAbstractFile methodsFor: 'accessing' stamp: 'akevalion 2/21/2017 11:54'!
filename: afileName
	filename := afileName.
! !

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/30/2016 15:52'!
getSource
	"Return the source code of the file"
	| c |
	self fileReference exists ifFalse: [ ^ '' ].
	c := self fileReference contents.
	^ c isNil ifTrue: [ '' ] ifFalse: [ c ]! !

!CPPAbstractFile methodsFor: 'inspector' stamp: 'AlexandreBergel 11/30/2016 13:46'!
gtInspectorTableIn: composite
	<gtInspectorPresentationOrder: -15>
	composite text
		title: 'Source';
		display: [ self getSource ]! !

CPPAbstractFile subclass: #CPPFile
	instanceVariableNames: 'includedNames incomingHeaders outgoingHeaders loc fileReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Core'!

!CPPFile methodsFor: 'adding' stamp: 'AlexandreBergel 11/7/2016 15:42'!
addIncomingHeader: h 
	"Add a header that references me"
	incomingHeaders add: h! !

!CPPFile methodsFor: 'adding' stamp: 'AlexandreBergel 11/7/2016 15:42'!
addOutgoingHeader: h
	"Add a header that is referenced by me"
	outgoingHeaders add: h! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 20:12'!
baseFilename
	^ (filename findTokens: '/') last
	 ! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:35'!
baseFilenameWithoutExtension
	| ts |
	ts := filename findTokens: '/.'.
	^ ts at: (ts size - 1)! !

!CPPFile methodsFor: 'gt inspector' stamp: 'AlexandreBergel 11/3/2016 20:18'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 5>
	fileReference ifNotNil: [ fileReference gtInspectorContentsIn: composite ]! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:34'!
includedNames
	"Return the list of names specified in the includes.
	For example, if the file contains #include <foo.h>
	Then the collection returned by includedName contains 'foo.h'"
	^ includedNames! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:34'!
incomingHeaders
	"Return the list of headers included by me"
	^ incomingHeaders! !

!CPPFile methodsFor: 'initialization' stamp: 'AlexandreBergel 11/7/2016 15:40'!
initialize
	super initialize.
	outgoingHeaders := OrderedCollection new.
	incomingHeaders := OrderedCollection new.
	includedNames := OrderedCollection new.
	self filename: 'UNAMED'.
	self loc: -1.! !

!CPPFile methodsFor: 'initialization' stamp: 'AlexandreBergel 12/5/2016 10:02'!
initializeFromContentAsString: string
	| lines includesLines ss |
	lines := string lines.
	loc := lines size.
	
	includesLines := lines select: [ :l | l beginsWith: '#include ' ].
	includesLines do: [ :l |
		ss := l findTokens: '<>"'.
		ss size = 2 ifTrue: [ includedNames add: ss second ]
	 ].
! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:35'!
loc
	"Return the number of lines of code of the file"
	^ loc! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:35'!
loc: anInteger
	"Set the number of lines of code of the file"
	loc := anInteger! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:40'!
outgoingHeaders
	^ outgoingHeaders! !

!CPPFile methodsFor: 'printing' stamp: 'AlexandreBergel 11/3/2016 20:09'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	filename notEmpty ifTrue: [ str nextPutAll: filename ].
	str nextPut: $>! !

CPPFile subclass: #CPPHeader
	instanceVariableNames: 'module'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Core'!

!CPPHeader methodsFor: 'testing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
hasModule
	^ module notNil! !

!CPPHeader methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:28'!
module
	^ module! !

!CPPHeader methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:28'!
module: anObject
	module := anObject! !

CPPFile subclass: #CPPModule
	instanceVariableNames: 'header dependentModules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Core'!

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/30/2016 16:06'!
addDependentModules: someModules
	self assert: [ someModules allSatisfy: [ :m | m class == self class ] ].
	dependentModules addAll: (someModules copyWithout: self).
	dependentModules removeDuplicates ! !

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/16/2016 16:57'!
dependOn: aRegExp
	^ self dependentModules anySatisfy: [ :m | aRegExp match: m filename ]! !

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
dependentModules
	^ dependentModules! !

!CPPModule methodsFor: 'testing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
hasHeader
	^ header notNil! !

!CPPModule methodsFor: 'testing' stamp: 'AlexandreBergel 12/18/2016 11:48'!
hasNoHeader
	^ self hasHeader not! !

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
header
	^ header! !

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
header: anObject
	header := anObject! !

!CPPModule methodsFor: 'initialization' stamp: 'AlexandreBergel 11/3/2016 19:52'!
initialize
	super initialize.
	dependentModules := OrderedCollection new! !

CPPAbstractFile subclass: #CPPFolder
	instanceVariableNames: 'files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Core'!

!CPPFolder methodsFor: 'adding' stamp: 'AlexandreBergel 11/7/2016 15:48'!
addFile: aFile
	files add: aFile! !

!CPPFolder methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:48'!
files
	^ files copy! !

!CPPFolder methodsFor: 'initialization' stamp: 'AlexandreBergel 11/7/2016 15:47'!
initialize
	super initialize.
	files := OrderedCollection new! !

!CPPFolder methodsFor: 'metrics' stamp: 'AlexandreBergel 11/7/2016 15:48'!
numberOfFiles
	^ files size! !

RTObject subclass: #CPPProcessor
	instanceVariableNames: 'headers modules directories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer-Core'!

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 3/8/2017 21:46'!
headerNamed: afileName
	| entry |
	entry := (afileName includes: $/)
		ifTrue: [ afileName copyFrom: (afileName lastIndexOf: $/) + 1 to: afileName size ]
		ifFalse: [ afileName ].
	^ headers at: entry ifAbsent: [ nil ]
	"^ headers detect: [ :h | h baseFilename = afileName ] ifNone: [ nil ]"! !

!CPPProcessor methodsFor: 'accessing' stamp: 'AlexandreBergel 12/2/2016 18:59'!
headers
	^ headers values! !

!CPPProcessor methodsFor: 'initialization' stamp: 'AlexandreBergel 12/2/2016 18:59'!
initialize
	super initialize.
	headers := Dictionary new.
	modules := Dictionary new.
	directories := OrderedCollection new! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 12/2/2016 19:01'!
moduleNamed: afileName
	^ modules at: afileName ifAbsent: [ nil ]
	"^ modules detect: [ :m | m baseFilename = afileName ] ifNone: [ nil ]"! !

!CPPProcessor methodsFor: 'accessing' stamp: 'AlexandreBergel 12/2/2016 19:01'!
modules
	^ modules values! !

!CPPProcessor methodsFor: 'metrics' stamp: 'AlexandreBergel 11/7/2016 15:54'!
numberOfDirectories
	^ directories size! !

!CPPProcessor methodsFor: 'metrics' stamp: 'AlexandreBergel 11/3/2016 19:14'!
numberOfHeaders
	^ headers size! !

!CPPProcessor methodsFor: 'metrics' stamp: 'AlexandreBergel 11/3/2016 19:14'!
numberOfModules
	^ modules size! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/7/2016 16:04'!
processDirectories: listOfDirectories

	"TODO"
	"Hum... Not sure whether we will keep the folders..."! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 3/8/2017 21:15'!
processFileAsString: fileContentAsString named: filename
	(((filename endsWith: '.c') or: [ filename endsWith: '.cpp' ]) or: [ filename endsWith: '.cc' ])
		ifTrue: [ ^ self processModuleAsString: fileContentAsString named: filename ].

	((filename endsWith: '.h') or: [ filename endsWith: '.hpp' ])
		ifTrue: [ ^ self processHeaderAsString: fileContentAsString named: filename ].
		! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 12/2/2016 19:00'!
processHeaderAsString: fileContentAsString named: filename 
	| h |
	h := CPPHeader new.
	h filename: filename.
	h initializeFromContentAsString: fileContentAsString.
	headers at: h baseFilename put: h
	"headers add: h"! !

!CPPProcessor methodsFor: 'processing' stamp: 'akevalion 2/21/2017 12:02'!
processModuleAsString: fileContentAsString named: filename
	| m |
	m := CPPModule new.
	m filename: filename.
	m initializeFromContentAsString: fileContentAsString.
	modules at: m baseFilename put: m
! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 3/8/2017 21:16'!
processRootFolder: aFileReference

	| relevantFiles allFiles allDirectories |
	allFiles := aFileReference allChildren.
	allDirectories := allFiles select: #isDirectory.
	self processDirectories: allDirectories.
	relevantFiles := allFiles select: [ :f | #('c' 'h' 'cpp' 'hpp' 'C' 'H' 'CPP' 'HPP' 'cc') includes: f extension ].
	relevantFiles do: [ :f | 
			| r |
			r := f readStream.
			r ascii.
			r converter: Latin1TextConverter new.
			self processFileAsString: r contents named: f pathString ].! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/30/2016 14:23'!
resolveDependencies

	self resolveDependenciesBetweenHeaderAndModule.
	self resolveDependenciesBetweenHeaders.
	self resolveDependenciesBetweenModulesAndHeaders.
	self resolveDependenciesBetweenModules! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 3/8/2017 21:13'!
resolveDependenciesBetweenHeaderAndModule
	| m |
	"We link header to modules, and modules to header"
	self headers do: [ :h |
		"We first look for a module whose name ends with .c"
		m := self moduleNamed: h baseFilenameWithoutExtension, '.c'.
		"If not found, we look for a module ending with .cpp"
		m ifNil: [ m := self moduleNamed: h baseFilenameWithoutExtension, '.cpp' ].
		"Else, ending with .cc"
		m ifNil: [ m := self moduleNamed: h baseFilenameWithoutExtension, '.cc' ].
		
		m ifNotNil: [ 
			m header: h. 
			h module: m ]
	].! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 12/2/2016 19:00'!
resolveDependenciesBetweenHeaders
	self headers copy do: [ :h |
		h includedNames do: [ :name |
			| hh |
			hh := self headerNamed: name.
			hh ifNotNil: [ 
				hh addIncomingHeader: h. 
				h addOutgoingHeader: hh ] ]
	]! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 12/2/2016 19:01'!
resolveDependenciesBetweenModules
	self modules copy do: [ :m |
		"We first use the header to extract the dependencies between the modules"
		m hasHeader ifTrue: [ 
			| oh |
			oh := m header outgoingHeaders, m outgoingHeaders. 
			oh := oh select: #hasModule thenCollect: #module.
			m addDependentModules: oh. ].
	].
! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 3/8/2017 21:46'!
resolveDependenciesBetweenModulesAndHeaders
	self modules copy do: [ :m |
		m includedNames do: [ :name | 
			| hh |
			hh := self headerNamed: name.
			hh ifNotNil: [ 
				m addOutgoingHeader: hh ] ]
	].
! !
